;;
;; md5 - Scheme wrapper for Colin Plumb's Public Domain md5 implementation
;;
;; All code in this egg is in the Public Domain
(module md5
  (md5-digest md5-binary-digest md5-primitive)

(import chicken scheme foreign)
(use message-digest)

(foreign-declare "#include \"md5-base.c\"")

(define digest-length 16)

(define context-size (foreign-value "sizeof(struct MD5Context)" unsigned-int))

(define init (foreign-lambda void MD5Init c-pointer))
(define update (foreign-lambda void MD5Update c-pointer scheme-pointer unsigned-int))
(define final (foreign-lambda void MD5Final c-pointer scheme-pointer))

(define (md5-binary-digest obj)
  (make-binary-message-digest
   obj context-size digest-length init update final 'md5-binary-digest))

(define (md5-digest obj)
  (make-message-digest
   obj context-size digest-length init update final 'md5-digest))

(define md5-primitive
  (let ((the-md5-primitive #f))
    (lambda ()
      (unless the-md5-primitive
        (set! the-md5-primitive
              (make-message-digest-primitive context-size digest-length
                                             init update final 'md5-primitive)) )
      the-md5-primitive ) ) )
)
